//bw_real_fw.c

//improved firmware to measure the bandwidth of the USB interface

//             (C) Marko Cebokli S57UUU  Oct 2006 
//             GNU/GPL licence:  www.gnu.org/licences/licences.html#GPL

//Compile with SDCC:     sdcc -mmcs51 bw_real_fw.c

#define ALLOCATE_EXTERN
#include "fx2regs2.h"

//#define NOP   _asm \ nop; \ nop; \ _endasm;		//for IFCLK=48,  CPUCLK=12
#define NOP   _asm \ nop; \ nop; \ nop; \ _endasm;	//for IFCLK=48,  CPUCLK=48
#undef NOP
#define NOP

void main(void)
{
unsigned char i;
unsigned int j,k;
int m;
int *cnt = (int*)&EP8FIFOBUF[2];

//the value in the "del" variable sets the simulated data rate
int del=28;	//120=2MB/s  60=4MB/s  28=8MB/s  12=16MB/s

REVCTL=0x03;NOP;
CPUCS=0x12;NOP;			//crank up CPU to 48MHz

i=0;
m=0;	//needed to outsmart SDCC optimization!
EP8FIFOBUF[2]=0;EP8FIFOBUF[3]=0;
while (1)
	{
	for (k=0;k<del;k++){m++;}	//delay loop which sets data rate
	j=0;
	EP8FIFOBUF[2]=0;EP8FIFOBUF[3]=0;
	EP8FIFOBUF[8]=m;		//needed to outsmart SDCC optimization!
	while (EP8CS & bmBIT3)		//if buffer not ready, count time
		{
		j++;
		*cnt=j;			//send wait time to host
		}
	EP8FIFOBUF[0]=i;
	i++;
	EP8BCH=0x02;
	EP8BCL=0x00;NOP;		//arm endpoint
	}
}
